with Text_Io;                          use Text_Io;
with Ada.Long_Integer_Text_Io;         use Ada.Long_Integer_Text_Io;
with Ada.Integer_Text_Io;              use Ada.Integer_Text_Io;
with Ada.Float_Text_Io;                use Ada.Float_Text_Io;
with Ada.Numerics.Discrete_Random;
with Calendar;                         use Calendar; 

procedure HTS2 is
   pragma Suppress (All_Checks);
   package Boolean_Io is new Enumeration_Io(Boolean);use Boolean_Io; 
   Objective_value,Target:Integer;
   Threshold_For_One_Opt:Integer;
   Threshold_For_Two_Opt:Integer;
   Threshold_For_Three_Opt:Integer;
   Threshold_For_Ts_Opt:Integer;       
   Tabutenure:Integer;
   Tssetmin:Integer;
   Exact_Search_Threshold1:Integer;
   Exact_Search_Threshold2:Integer;
   Ijiter:Long_Integer;--:=999999999;
   Infile:File_Type;
   Tempfilename:String(1..80);
   Line_Length:Natural;
   -- Firstline1_2:String(1..80);
   Perfile:Text_Io.File_Type;
   Ts_Output,Usecustomparameters,Usecustomtssetmin:Boolean;
   Custom_Threshold_For_One_Opt:Integer;
   Custom_Threshold_For_Two_Opt:Integer;
   Custom_Threshold_For_Three_Opt:Integer;
   Custom_Threshold_For_Ts_Opt:Integer;       
   Custom_Tssetmin:Integer;
   Custom_Exact_Search_Threshold1:Integer;
   Custom_Exact_Search_Threshold2:Integer;
   
   function Readfilename(Line_Length:in Natural) return String is
      Ccount:Integer:=0;
   begin
      for I in 1..Line_Length loop 
         if Tempfilename(I) = ' ' then exit; end if;
         Ccount:=Ccount+1;
      end loop;
      declare
         Filename:String(1..Ccount);
      begin
         for I in 1..Ccount loop
            Filename(I):= Tempfilename(I);
         end loop;
         return Filename;
      end;
   end Readfilename;

                     
   procedure Inside_New_Maxclq is
      V,E:Integer;
      subtype Bin is Integer range 0..1;
      type Two_D is array(Integer range <>,Integer range <> ) of Bin;
      type One_D is array(Integer range <> ) of Bin; 
      type Two_D_Integer is array(Integer range <>,Integer range <> ) of Integer;
      type One_D_Integer is array(Integer range <> ) of Integer;      
      type Ref_Matrix is access Two_D;
      type Ref_Vector is access One_D;
      type Ref_Matrix_Integer is access Two_D_Integer;
      type Ref_Vector_Integer is access One_D_Integer;
      subtype Stv is Integer range 1..32000; 
      package Randomstv is 
      new Ada.Numerics.Discrete_Random (Result_Subtype => Stv);
      G: Randomstv.Generator;
      Logfile:Text_Io.File_Type;
      Now:Time:=Clock;
      A:Ref_Matrix;
      Adj:Ref_Matrix_Integer;
      Adjsizes:Ref_Vector_Integer;
      Notadj:Ref_Matrix_Integer;
      Notadjsizes:Ref_Vector_Integer;
      Size_Current_Best_Clique,Size_Overall_Best_Clique,Adjchoices,Adjsizesmax,Notadjsizesmax,K,K2,Ddays,Bestsize,Size_Before,Size_Current_Best_Opt,Size_Current_Opt:Integer;
      Sseconds,Elapsed:Long_Integer;
      Totaltscount:Long_Integer:=0;
      Char:Character;
      Elapsed_Start:Long_Integer;
      Best:One_D_Integer(1..Target);
      Isclique,First:Boolean:=False;
      Current_Opt:One_D_Integer(1..Target);
      Current_Best_Opt,Tsbest:One_D_Integer(1..Target);
      Size_Tsbest:Integer;
      --TO FIND LAMBDA AND THETA PARAMETRS
      Density:Float;
      First_Best,Second_Best,Theta_Value:Integer;
      First_Best_Repeat,Starting:Boolean;
      Ik:Long_Integer;
         
      procedure Readinline1(V1,E: out Integer) is
         Ch:Character;
         Str:String(1..6);--E:Integer; works for brock400_2
         --Str:String(1..5);--E:Integer; works for C2000_9
      begin
         Open(File=>Perfile,Mode=>In_File,Name=>Readfilename(Line_Length));
         Get(Perfile,Str);if Str(6) = 'g' then Get(Perfile,Ch); end if;
         Get(Perfile,V1);Get(Perfile,E);--Put(Ch);Put(Str);Put(V1);Put(E);
         Skip_Line(Perfile);
      end Readinline1; 


      procedure Readin(V,E: in Integer; A: in out Ref_Matrix) is
         --     Perfile:Text_Io.File_Type;
         Ch:Character;
         I,J:Integer;
      begin
         for Jj in 1..E loop       
            Get(Perfile,Ch);Get(Perfile,Ch);Get(Perfile,I);Get(Perfile,J);--Put(I);Put(J); New_Line;             
            A(I,J):=1;A(J,I):=1;       
         end loop;               
         Close(Perfile);
      end Readin;
   
      function Randomsubset(Top: in Integer) return Integer is
      begin
         return (Randomstv.Random(Gen => G) mod Top) +1;
      end Randomsubset;
               
      procedure Carraghanpardalos6plus(S:in One_D_Integer;Ssize:in Integer;Ext_Thresh: in Integer) is 
      --ordered local colouring upper bound
         F:One_D_Integer(1..Target);
         Depth,Thisdeg,Maxdeg:Integer:=0;
         Sarray:Two_D_Integer(1..Target,1..V);
         Actualcolours:One_D_Integer(1..V); --for colouring bound
         Usedcolours:array(1..V) of Boolean; --for colouring bound
         Colourfound:Boolean;--for colouring bound
         Local_No_Colours:Integer; --for colouring bound
         Ssizes:One_D_Integer(1..Target);--:=1..Target:=0;
         Spointers:One_D_Integer(1..Target);
         Colourarray:Two_D_Integer(1..Ssize,1..Ssize); --for sorted colouring
         Colourcount:One_D_Integer(1..Ssize);  --for sorted colouring
         Localcolournumber:Two_D_Integer(1..Target,1..Ssize+1); --for sorted colouring
         Cno,Sarrayno:Integer; --for sorted colouring
      begin
         Depth:=1;
         Ssizes(1):=0;
         for I in 1..Ssize loop Sarray(1,I):=S(I);end loop; Ssizes(1):=Ssize;Spointers(1):=0;
                      --NOW COLOUR Sarray(1,1..Ssizes(1));               
                     Actualcolours(Sarray(1,1)):=1;Local_No_Colours:=1;
                     for I in 2..Ssizes(1) loop
                        for Ii in 1..I-1 loop
                           Usedcolours(Ii):=False;
                        end loop;  
                        for J in 1..I-1 loop
                           if A(Sarray(1,I),Sarray(1,J))=1 then Usedcolours(Actualcolours(Sarray(1,J))):=True;end if;
                        end loop;
                        Colourfound:=False;
                        for Jj in 1..Local_No_Colours loop 
                           if Usedcolours(Jj)=False then Actualcolours(Sarray(1,I)):=Jj;Colourfound:=True;exit;end if;
                        end loop;
                        if Colourfound=False then Local_No_Colours:=Local_No_Colours+1;Actualcolours(Sarray(1,I)):=Local_No_Colours;end if;
                     end loop;
                     --NOW SORT COLOURING
                     for Kk in 1..Ssizes(1) loop Colourcount(Kk):=0;end loop;
                     for Ll in 1..Ssizes(1) loop 
                        Colourcount(Actualcolours(Sarray(1,Ll))):=Colourcount(Actualcolours(Sarray(1,Ll)))+1;
                        Colourarray(Colourcount(Actualcolours(Sarray(1,Ll))),Actualcolours(Sarray(1,Ll))):=
                        Sarray(1,Ll);   
                     end loop;
                     Cno:=Local_No_Colours;Sarrayno:=1;
                     while Cno > 0 loop
                        for Cc in 1..Colourcount(Cno) loop
                           Sarray(1,Sarrayno):=Colourarray(Cc,Cno);
                           Localcolournumber(1,Sarrayno):=Cno;
                           Sarrayno:=Sarrayno+1;
                        end loop;
                        Cno:=Cno-1;
                     end loop;
                     Localcolournumber(1,Ssizes(1)+1):=0;
            --END COLOURING 
         while Depth > 1 or (Depth = 1 and Spointers(1) <= Ssizes(1)) loop                 
            Spointers(Depth):=Spointers(Depth)+1;
            if Spointers(Depth) > Ssizes(Depth) then Depth:=Depth-1;
            else 
              -- if Depth=1 then Localcolournumber(Depth,Spointers(Depth)+1):=Ssizes(Depth) - Spointers(Depth); end if;
               if Depth + Localcolournumber(Depth,Spointers(Depth)+1) > Bestsize and  Depth + Localcolournumber(Depth,Spointers(Depth)+1)  >= Ext_Thresh then
                  F(Depth):=Sarray(Depth,Spointers(Depth));
                  Ssizes(Depth+1):=0;
                  for I in Spointers(Depth)+1 .. Ssizes(Depth) loop
                     if A(F(Depth),Sarray(Depth,I))=1 then Sarray(Depth+1,Ssizes(Depth+1)+1):=Sarray(Depth,I);Ssizes(Depth+1):=Ssizes(Depth+1)+1;end if;
                  end loop;
                  if Depth > Bestsize and Ssizes(Depth+1)=0 then
                     Bestsize:=Depth;
                     for I in 1..Depth loop Best(I):=F(I);end loop;
                  elsif
                     (Depth+Ssizes(Depth+1) > Bestsize and Ssizes(Depth+1) > 0) and Depth+Ssizes(Depth+1) >= Ext_Thresh then
                     --NOW COLOUR Sarray(Depth+1,1..Ssizes(Depth+1));               
                     Actualcolours(Sarray(Depth+1,1)):=1;Local_No_Colours:=1;
                     for I in 2..Ssizes(Depth+1) loop
                        for Ii in 1..I-1 loop
                           Usedcolours(Ii):=False;
                        end loop;  
                        for J in 1..I-1 loop
                           if A(Sarray(Depth+1,I),Sarray(Depth+1,J))=1 then Usedcolours(Actualcolours(Sarray(Depth+1,J))):=True;end if;
                        end loop;
                        Colourfound:=False;
                        for Jj in 1..Local_No_Colours loop 
                           if Usedcolours(Jj)=False then Actualcolours(Sarray(Depth+1,I)):=Jj;Colourfound:=True;exit;end if;
                        end loop;
                        if Colourfound=False then Local_No_Colours:=Local_No_Colours+1;Actualcolours(Sarray(Depth+1,I)):=Local_No_Colours;end if;
                     end loop;
                     --NOW SORT COLOURING
                     for Kk in 1..Ssizes(Depth+1) loop Colourcount(Kk):=0;end loop;
                     for Ll in 1..Ssizes(Depth+1) loop 
                        Colourcount(Actualcolours(Sarray(Depth+1,Ll))):=Colourcount(Actualcolours(Sarray(Depth+1,Ll)))+1;
                        Colourarray(Colourcount(Actualcolours(Sarray(Depth+1,Ll))),Actualcolours(Sarray(Depth+1,Ll))):=
                        Sarray(Depth+1,Ll);   
                     end loop;
                     Cno:=Local_No_Colours;Sarrayno:=1;
                     while Cno > 0 loop
                        for Cc in 1..Colourcount(Cno) loop
                           Sarray(Depth+1,Sarrayno):=Colourarray(Cc,Cno);
                           Localcolournumber(Depth+1,Sarrayno):=Cno;
                           Sarrayno:=Sarrayno+1;
                        end loop;
                        Cno:=Cno-1;
                     end loop;
                     Localcolournumber(Depth+1,Ssizes(Depth+1)+1):=0;
                     --END COLOURING                 
                     if (Depth+Local_No_Colours > Bestsize and Ssizes(Depth+1) > 0) and Depth+Local_No_Colours >= Ext_Thresh then     
                        Depth:=Depth+1;Spointers(Depth):=0;
                     end if; ----colouring test
                  end if;--Depth > Bestsize and Ssizes(Depth+1)=0
               else Depth:=Depth-1;--Put("Bestsize = ");Put(Bestsize);New_Line;
               end if; --Depth + Ssizes(Depth) - Spointers(Depth).......
            end if;
         end loop;
      end Carraghanpardalos6plus;


      procedure Heur(V:in Integer; Ij: in Long_Integer; Size_Adjppath: out Integer; Adjppath: out One_D_Integer) is     
         Size_Adjppath_New,Adjneighsize,Adjneighsizestored,Adjneightempsize,Nexxt,Bestposn,Bestadjneighsize,Vx,Pposn,Posn,Size_Adjppath_Stored:Integer;
         Char:Character;
         Adjneighpoint:One_D_Integer(1..V);
         Adjneighpointstored:One_D_Integer(1..Adjsizesmax);
         Adjneighposn:One_D_Integer(1..V);
         Adjppath_Stored,Adjppath_New:One_D_Integer(1..Target);
         Exactstored:Boolean;
      begin 
         for I0 in 1..Target loop Adjppath(I0):=0; end loop; Size_Adjppath:=0;  
         case (Ij mod 10) is
            when 1 => Adjchoices:=1;
            when 2 => Adjchoices:=50;
            when 3 => Adjchoices:=80;
            when 4 => Adjchoices:=100;
            when 5 => Adjchoices:=120;
            when 6 => Adjchoices:=160;
            when 7 => Adjchoices:=200;
            when 8 => Adjchoices:=300;
            when 9 => Adjchoices:=600;
            when 0 => Adjchoices:=800;
            when others => Adjchoices:=1;
         end case;
         if (V<1000) and ((Adjchoices = 600) or (Adjchoices = 800)) then Adjchoices :=1; end if;
         Adjneighsize:=V;
         for I in 1..V loop Adjneighpoint(I):=I;Adjneighposn(I):=I; end loop;            
         --set up, including position array  - only necessary part of pointer array     
         Exactstored:=False;
         while Adjneighsize > 0 loop
            if Adjneighsize < (Threshold_For_One_Opt - Size_Adjppath) then exit; end if;  
            if Adjneighsize < Exact_Search_Threshold2  then 
               Bestsize:=0;
               declare 
                  Adjneighpointsmall:One_D_Integer(1..Adjneighsize);
               begin
                  for I in 1..Adjneighsize loop Adjneighpointsmall(I):=Adjneighpoint(I); end loop;
                  --Carraghanpardalos(Adjppath,0,Adjneighpointsmall,Adjneighsize,Threshold_For_One_Opt-Size_Adjppath);              
                  --Carraghanpardalos2(Adjneighpointsmall,Adjneighsize,Threshold_For_One_Opt-Size_Adjppath); 
                  Carraghanpardalos6plus(Adjneighpointsmall,Adjneighsize,Threshold_For_One_Opt-Size_Adjppath);
                  --Carraghanpardalos4(Adjneighpointsmall,Adjneighsize,0);
               end;           
               for Ii in 1..Bestsize loop
                  Adjppath(Size_Adjppath+1):=Best(Ii);Size_Adjppath:=Size_Adjppath+1;   
               end loop;
               if Size_Adjppath >= Threshold_For_One_Opt and Starting=False then Put("Bestsize = ");Put(Bestsize);Put(" Size_Adjppath = ");Put(Size_Adjppath); New_Line;Flush; end if;                           
               exit;               
            end if; --END OF EXACT SEARCH CODE
            --NOW STORE LARGER EXACT SEARCH PROBLEM
            if Adjneighsize < Exact_Search_Threshold1 and Exactstored = False then
               Adjneighsizestored:=Adjneighsize;
               for I in 1..Adjneighsize loop Adjneighpointstored(I):=Adjneighpoint(I); end loop;
               Size_Adjppath_Stored:=Size_Adjppath;
               for I in 1..Target loop Adjppath_Stored(I):=Adjppath(I); end loop;
               Exactstored:=True;
               -- Put("Adjneighsizestored = ");Put(Adjneighsizestored); Put("  Size_Adjppath_Stored = ");Put(Size_Adjppath_Stored);New_Line;Flush;
            end if;
            --END OF STORE LARGER EXACT SEARCH PROBLEM
            if Adjchoices = 1 then
               Pposn:=Randomsubset(Adjneighsize);
               Nexxt:=Adjneighpoint(Pposn);
               Adjppath(Size_Adjppath+1):=Nexxt;Size_Adjppath:=Size_Adjppath+1;if Size_Adjppath > Target - 3 then Put("Target too small"); Get(Char);end if;
               -- now update adjneighpoint and adjneigh posn
               if Adjneighpoint(Adjneighsize) = Nexxt then Adjneighsize:=Adjneighsize-1;else
                  Adjneighpoint(Pposn):=Adjneighpoint(Adjneighsize);
                  Adjneighposn(Adjneighpoint(Adjneighsize)):=Pposn; 
                  Adjneighpoint(Adjneighsize):=Nexxt;
                  Adjneighposn(Nexxt):=Adjneighsize;
                  Adjneighsize:=Adjneighsize-1;
               end if;   
               if Adjneighsize > 0 then
                  for I in 1..Notadjsizes(Nexxt) loop
                     if Adjneighposn(Notadj(Nexxt,I)) = Adjneighsize then Adjneighsize:=Adjneighsize-1;end if;
                     if Adjneighposn(Notadj(Nexxt,I)) < Adjneighsize then Pposn:=Adjneighposn(Notadj(Nexxt,I));             
                        Adjneighpoint(Pposn):=Adjneighpoint(Adjneighsize);   
                        Adjneighposn(Adjneighpoint(Adjneighsize)):=Pposn;   
                        Adjneighpoint(Adjneighsize):=Notadj(Nexxt,I);  
                        Adjneighposn(Notadj(Nexxt,I)):=Adjneighsize;  
                        Adjneighsize:=Adjneighsize-1;  
                     end if;
                  end loop;               
               end if;
               --adjneigh updated
            end if; --Adjchoices Eq 1 	end of Adjchoices Eq 1 Code
            if Adjchoices /= 1 then
               if Adjneighsize < Adjchoices then 
                  Bestadjneighsize:=0;Nexxt:=Adjneighpoint(1);
                  for Vv in 1..Adjneighsize loop
                     Vx:=Adjneighpoint(Vv);
                     Adjneightempsize:=Adjneighsize-1;--Vx removed
                     for W in 1..Notadjsizes(Vx) loop
                        if Adjneighposn(Notadj(Vx,W)) <= Adjneightempsize then Adjneightempsize:=Adjneightempsize - 1; end if;
                     end loop;
                     if Adjneightempsize > Bestadjneighsize then Bestadjneighsize:=Adjneightempsize;Nexxt:=Vx;Pposn:=Vv; end if;
                  end loop;
               else
                  Bestposn:=1;Bestadjneighsize:=0;
                  for Z in 1..Adjchoices loop
                     Posn:=Randomsubset(Adjneighsize);
                     Vx:=Adjneighpoint(Posn);
                     Adjneightempsize:=Adjneighsize-1;--Vx removed
                     for W in 1..Notadjsizes(Vx) loop
                        if Adjneighposn(Notadj(Vx,W)) <= Adjneightempsize then Adjneightempsize:=Adjneightempsize - 1; end if;
                     end loop;
                     if Adjneightempsize > Bestadjneighsize then Bestadjneighsize:=Adjneightempsize;Nexxt:=Vx;Pposn:=Posn; end if;
                  end loop;
               end if;
               --            -- Put("now add adjnexxt to adjppath and update adjneigh");
               Adjppath(Size_Adjppath+1):=Nexxt;Size_Adjppath:=Size_Adjppath+1;if Size_Adjppath > Target - 3 then Put("Target too small"); Get(Char);end if;
               -- now update adjneighpoint and adjneigh posn
               if Adjneighpoint(Adjneighsize) = Nexxt then Adjneighsize:=Adjneighsize-1;else
                  Adjneighpoint(Pposn):=Adjneighpoint(Adjneighsize);
                  Adjneighposn(Adjneighpoint(Adjneighsize)):=Pposn; 
                  Adjneighpoint(Adjneighsize):=Nexxt;
                  Adjneighposn(Nexxt):=Adjneighsize;
                  Adjneighsize:=Adjneighsize-1;
               end if;   
               if Adjneighsize > 0 then
                  for I in 1..Notadjsizes(Nexxt) loop
                     if Adjneighposn(Notadj(Nexxt,I)) = Adjneighsize then Adjneighsize:=Adjneighsize-1;end if;
                     if Adjneighposn(Notadj(Nexxt,I)) < Adjneighsize then Pposn:=Adjneighposn(Notadj(Nexxt,I));             
                        Adjneighpoint(Pposn):=Adjneighpoint(Adjneighsize);   
                        Adjneighposn(Adjneighpoint(Adjneighsize)):=Pposn;   
                        Adjneighpoint(Adjneighsize):=Notadj(Nexxt,I);  
                        Adjneighposn(Notadj(Nexxt,I)):=Adjneighsize;  
                        Adjneighsize:=Adjneighsize-1;  
                     end if;
                  end loop;               
               end if;
            end if;
         end loop; --end while
         if Exactstored = True and Size_Adjppath >= Threshold_For_One_Opt then
            --Bestsize:=0;
            --Temp:=Size_Adjppath;
            declare 
               Adjneighpointsmall:One_D_Integer(1..Adjneighsizestored);
            begin
               for I in 1..Adjneighsizestored loop Adjneighpointsmall(I):=Adjneighpointstored(I); end loop;
               --Carraghanpardalos(Adjppath,0,Adjneighpointsmall,Adjneighsizestored,Threshold_For_One_Opt-Threshold_For_One_Opt-Size_Adjppath_Stored);      
               --Carraghanpardalos2(Adjneighpointsmall,Adjneighsizestored,Threshold_For_One_Opt-Size_Adjppath_Stored);
               Carraghanpardalos6plus(Adjneighpointsmall,Adjneighsizestored,Threshold_For_One_Opt-Size_Adjppath_Stored);
               --Carraghanpardalos4(Adjneighpointsmall,Adjneighsizestored,0);
            end; 
            --Put("Bestsize from stored =");Put(Bestsize);New_Line;Flush;
            Size_Adjppath_New:=Size_Adjppath_Stored;
            if Size_Adjppath_New + Bestsize > Size_Adjppath  then
               for Ii in 1..Size_Adjppath_Stored loop  Adjppath_New(Ii):=Adjppath_Stored(Ii); end loop;         
               for Ii in 1..Bestsize loop Adjppath_New(Size_Adjppath_New+1):=Best(Ii);Size_Adjppath_New:=Size_Adjppath_New+1;end loop;
               if Starting=False then Put("Size_Adjppath_New = "); Put(Size_Adjppath_New);New_Line;Put("IMPROVEMENT ");New_Line;Flush;end if;
               Size_Adjppath:=Size_Adjppath_New; for I in 1..Size_Adjppath loop Adjppath(I):=Adjppath_New(I);end loop;         
            else if Starting=False then Put("NO IMPROVEMENT");Put("  Size_Adjppath_Stored = ");Put(Size_Adjppath_Stored);New_Line;end if;
            end if;
         end if;
      end Heur; 
   
      procedure One_Opt_Recursive(V:in Integer; Size_Current_Best_Clique: in out Integer; Current_Best_Clique: in out One_D_Integer) is
         Adjneighpoint:One_D_Integer(1..Adjsizesmax);
         Oneless:One_D_Integer(1..Target);
         Size_Oneless,Temp,Jjj:Integer;
         Adjneighsize:Integer;
      begin
         for Vvi in 1..Size_Current_Best_Clique loop
            Bestsize:=0;
            for I in 1..Size_Current_Best_Clique loop Oneless(I):=Current_Best_Clique(I);end loop;Size_Oneless:=Size_Current_Best_Clique;
            if Vvi = Size_Current_Best_Clique then Size_Oneless:=Size_Oneless-1; else
               Temp:=Oneless(Vvi);
               Oneless(Vvi):=Oneless(Size_Oneless);
               Oneless(Size_Oneless):=Temp;
               Size_Oneless:=Size_Oneless-1;
            end if;
            Adjneighsize:=Notadjsizes(Temp);
            for I in 1.. Adjneighsize loop Adjneighpoint(I):=Notadj(Temp,I); end loop;
            Jjj:=Adjneighsize;
            while Jjj>0 loop
               for J in 1.. Size_Oneless loop
                  if A(Oneless(J),Adjneighpoint(Jjj))=0 then 
                     if Jjj = Adjneighsize then Adjneighsize:=Adjneighsize-1;exit; else
                        Temp:=Adjneighpoint(Jjj);Adjneighpoint(Jjj):=Adjneighpoint(Adjneighsize);
                        Adjneighpoint(Adjneighsize):=Temp;Adjneighsize:=Adjneighsize-1;exit; 
                     end if;
                  end if;
               end loop; 
               Jjj:=Jjj-1;
            end loop;
            if Adjneighsize > 1 then 
               declare 
                  Adjneighpointsmall:One_D_Integer(1..Adjneighsize);
               begin
                  for I in 1..Adjneighsize loop Adjneighpointsmall(I):=Adjneighpoint(I); end loop;
                  --Carraghanpardalos(Oneless,0,Adjneighpointsmall,Adjneighsize,2);
                  Carraghanpardalos6plus(Adjneighpointsmall,Adjneighsize,2);
               end;
               if Bestsize > 1 then 
                  for I in 1..Bestsize loop Current_Opt(I):=Best(I);end loop;
                  for I in 1..Size_Oneless loop Current_Opt(Bestsize+I):=Oneless(I);end loop;
                  Size_Current_Opt:=Bestsize+Size_Oneless;
                  if Size_Current_Opt > Size_Current_Best_Opt then 
                     Size_Current_Best_Opt:=Size_Current_Opt;Current_Best_Opt:=Current_Opt;
                  end if;
                  --exit;
                  One_Opt_Recursive(V,Size_Current_Opt,Current_Opt);                        
               end if; --Bestsize > 1
            end if; --adjneighsize > 1
         end loop; -- Vvi in
      end One_Opt_Recursive;

      procedure Two_Opt_Recursive(V:in Integer; Size_Current_Best_Clique: in out Integer; Current_Best_Clique: in out One_D_Integer) is
         Adjneighpoint:One_D_Integer(1..V);
         Twoless:One_D_Integer(1..Target);
         Size_Twoless,Temp,Temp1,Temp2,Jjj,I1,I2:Integer;
         Adjneighsize,Icount:Integer;
         I1finished,I2finished:Boolean;
      begin
         for Vvi in 1..Size_Current_Best_Clique-1 loop
            for Vvj in Vvi+1..Size_Current_Best_Clique loop
               Bestsize:=0;
               for I in 1..Size_Current_Best_Clique loop Twoless(I):=Current_Best_Clique(I);end loop;Size_Twoless:=Size_Current_Best_Clique;
               if Vvj = Size_Current_Best_Clique then Size_Twoless:=Size_Twoless-1; else--Temp1:=Twoless(Vvj); else
                  Temp1:=Twoless(Vvj);
                  Twoless(Vvj):=Twoless(Size_Twoless);
                  Twoless(Size_Twoless):=Temp1;
                  Size_Twoless:=Size_Twoless-1;
               end if;
               if Vvi = Size_Twoless then Size_Twoless:=Size_Twoless-1; else --Temp2:=Twoless(Vvi); else
                  Temp2:=Twoless(Vvi);
                  Twoless(Vvi):=Twoless(Size_Twoless);
                  Twoless(Size_Twoless):=Temp2;
                  Size_Twoless:=Size_Twoless-1;
               end if;
               I1:=1;I2:=1;Adjneighsize:=0;Icount:=1;
               if Notadjsizes(Temp1)>0 then I1finished:=False; else I1finished:=True; end if;
               if Notadjsizes(Temp2)>0 then I2finished:=False; else I2finished:=True; end if;
               while I1finished = False or I2finished = False loop 
                  if I1finished = False and I2finished = False then
                     if Notadj(Temp1,I1) = Notadj(Temp2,I2) then 
                        Adjneighpoint(Icount):=Notadj(Temp1,I1);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I1:=I1+1;I2:=I2+1;
                        if I1 > Notadjsizes(Temp1) then I1finished:=True; end if;
                        if I2 > Notadjsizes(Temp2) then I2finished:=True; end if;  
                     elsif Notadj(Temp1,I1) > Notadj(Temp2,I2) then 
                        Adjneighpoint(Icount):=Notadj(Temp2,I2);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1;I2:=I2+1;
                        if I2 > Notadjsizes(Temp2) then I2finished:=True; end if; 
                     elsif Notadj(Temp1,I1) < Notadj(Temp2,I2) then 
                        Adjneighpoint(Icount):=Notadj(Temp1,I1);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I1:=I1+1;
                        if I1 > Notadjsizes(Temp1) then I1finished:=True; end if;
                     end if;   
                     --end if; --i1finished = false and i2finished = false
                  elsif I1finished = False and I2finished = True then
                     Adjneighpoint(Icount):=Notadj(Temp1,I1);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I1:=I1+1;
                     if I1 > Notadjsizes(Temp1) then I1finished:=True; end if;
                  elsif I1finished = True and I2finished = False then
                     Adjneighpoint(Icount):=Notadj(Temp2,I2);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I2:=I2+1;
                     if I2 > Notadjsizes(Temp2) then I2finished:=True; end if;
                  end if;
               end loop; --while loop - I1finished = False or I2finished = False        
               Jjj:=Adjneighsize;
               while Jjj>0 loop
                  for J in 1.. Size_Twoless loop
                     if A(Twoless(J),Adjneighpoint(Jjj))=0 then 
                        if Jjj = Adjneighsize then Adjneighsize:=Adjneighsize-1; exit; else
                           Temp:=Adjneighpoint(Jjj);Adjneighpoint(Jjj):=Adjneighpoint(Adjneighsize);
                           Adjneighpoint(Adjneighsize):=Temp;Adjneighsize:=Adjneighsize-1; exit; 
                        end if;
                     end if;
                  end loop; 
                  Jjj:=Jjj-1;
               end loop;--while Jjj>0 loop
               if Adjneighsize > 2 then 
                  declare 
                     Adjneighpointsmall:One_D_Integer(1..Adjneighsize);
                  begin
                     for I in 1..Adjneighsize loop Adjneighpointsmall(I):=Adjneighpoint(I); end loop;
                     --Carraghanpardalos(Twoless,0,Adjneighpointsmall,Adjneighsize,3);
                     Carraghanpardalos6plus(Adjneighpointsmall,Adjneighsize,3);
                  end;
                  if Bestsize > 2 then 
                     for I in 1..Bestsize loop Current_Opt(I):=Best(I);end loop;
                     for I in 1..Size_Twoless loop Current_Opt(Bestsize+I):=Twoless(I);end loop;
                     Size_Current_Opt:=Bestsize+Size_Twoless;
                     if Size_Current_Opt > Size_Current_Best_Opt then 
                        Size_Current_Best_Opt:=Size_Current_Opt;Current_Best_Opt:=Current_Opt;
                     end if;
                     Two_Opt_Recursive(V,Size_Current_Opt,Current_Opt);                     
                  end if; --Bestsize > 2
               end if; --adjneighsize > 2
            end loop; -- Vvj in
         end loop; -- Vvi in
      end Two_Opt_Recursive;
   
      procedure Three_Opt_Recursive(V:in Integer; Size_Current_Best_Clique: in out Integer; Current_Best_Clique: in out One_D_Integer) is
         Adjneighpoint:One_D_Integer(1..V);
         Threeless:One_D_Integer(1..Target);
         Size_Threeless,Temp,Temp1,Temp2,Temp3,Jjj,I1,I2,I3:Integer;
         Adjneighsize,Icount:Integer;
         --  Adjneigh:One_D(1..V);--:=(1..V=>0);
         I1finished,I2finished,I3finished:Boolean;
      begin
         for Vvi in 1..Size_Current_Best_Clique-2 loop --Put("vvi = ");Put(Vvi);
            for Vvj in Vvi+1..Size_Current_Best_Clique-1 loop
               for Vvk in Vvj+1..Size_Current_Best_Clique loop
                  Bestsize:=0;               
                  for I in 1..Size_Current_Best_Clique loop Threeless(I):=Current_Best_Clique(I);end loop;Size_Threeless:=Size_Current_Best_Clique;
                  if Vvk = Size_Current_Best_Clique then Size_Threeless:=Size_Threeless-1; else--Temp1:=threeless(Vvk); else
                     Temp1:=Threeless(Vvk);
                     Threeless(Vvk):=Threeless(Size_Threeless);
                     Threeless(Size_Threeless):=Temp1;
                     Size_Threeless:=Size_Threeless-1;
                  end if;               
                  if Vvj = Size_Current_Best_Clique then Size_Threeless:=Size_Threeless-1; else--Temp2:=threeless(Vvj); else
                     Temp2:=Threeless(Vvj);
                     Threeless(Vvj):=Threeless(Size_Threeless);
                     Threeless(Size_Threeless):=Temp2;
                     Size_Threeless:=Size_Threeless-1;
                  end if;
                  if Vvi = Size_Threeless then Size_Threeless:=Size_Threeless-1; else --Temp3:=threeless(Vvi); else
                     Temp3:=Threeless(Vvi);
                     Threeless(Vvi):=Threeless(Size_Threeless);
                     Threeless(Size_Threeless):=Temp3;
                     Size_Threeless:=Size_Threeless-1;
                  end if;
                  I1:=1;I2:=1;I3:=1;Adjneighsize:=0;Icount:=1;
                  if Notadjsizes(Temp1)>0 then I1finished:=False; else I1finished:=True; end if;
                  if Notadjsizes(Temp2)>0 then I2finished:=False; else I2finished:=True; end if;
                  if Notadjsizes(Temp3)>0 then I3finished:=False; else I3finished:=True; end if;
                  while (I1finished = False or I2finished = False) or I3finished = False loop
                     if (I1finished = False and I2finished = False) and I3finished = False then
                        if (Notadj(Temp1,I1) = Notadj(Temp2,I2)) and Notadj(Temp2,I2) = Notadj(Temp3,I3) then  --1/13
                           Adjneighpoint(Icount):=Notadj(Temp1,I1);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I1:=I1+1;I2:=I2+1;I3:=I3+1;
                           if I1 > Notadjsizes(Temp1) then I1finished:=True; end if;
                           if I2 > Notadjsizes(Temp2) then I2finished:=True; end if;  
                           if I3 > Notadjsizes(Temp3) then I3finished:=True; end if;
                        elsif  ((Notadj(Temp1,I1) = Notadj(Temp2,I2)) and Notadj(Temp2,I2) > Notadj(Temp3,I3) and Notadj(Temp1,I1) > Notadj(Temp3,I3)) then --2/13
                           Adjneighpoint(Icount):=Notadj(Temp3,I3);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I3:=I3+1;
                           if I3 > Notadjsizes(Temp3) then I3finished:=True; end if;
                        elsif ((Notadj(Temp1,I1) = Notadj(Temp2,I2)) and Notadj(Temp2,I2) < Notadj(Temp3,I3) and Notadj(Temp1,I1) < Notadj(Temp3,I3))  then  --3/13
                           Adjneighpoint(Icount):=Notadj(Temp1,I1);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I1:=I1+1;I2:=I2+1;
                           if I1 > Notadjsizes(Temp1) then I1finished:=True; end if;
                           if I2 > Notadjsizes(Temp2) then I2finished:=True; end if;  
                        elsif ((Notadj(Temp1,I1) < Notadj(Temp2,I2)) and Notadj(Temp2,I2) = Notadj(Temp3,I3) and Notadj(Temp1,I1) < Notadj(Temp3,I3))  then  --4/13
                           Adjneighpoint(Icount):=Notadj(Temp1,I1);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I1:=I1+1;
                           if I1 > Notadjsizes(Temp1) then I1finished:=True; end if;
                        elsif ((Notadj(Temp1,I1) > Notadj(Temp2,I2)) and Notadj(Temp2,I2) = Notadj(Temp3,I3) and Notadj(Temp1,I1) > Notadj(Temp3,I3))  then  --5/13
                           Adjneighpoint(Icount):=Notadj(Temp2,I2);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I2:=I2+1;I3:=I3+1;
                           if I2 > Notadjsizes(Temp2) then I2finished:=True; end if;  
                           if I3 > Notadjsizes(Temp3) then I3finished:=True; end if;
                        elsif ((Notadj(Temp1,I1) > Notadj(Temp2,I2)) and Notadj(Temp2,I2) < Notadj(Temp3,I3) and Notadj(Temp1,I1) = Notadj(Temp3,I3))  then  --6/13
                           Adjneighpoint(Icount):=Notadj(Temp2,I2);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I2:=I2+1;
                           if I2 > Notadjsizes(Temp2) then I2finished:=True; end if;  
                        elsif ((Notadj(Temp1,I1) < Notadj(Temp2,I2)) and Notadj(Temp2,I2) > Notadj(Temp3,I3) and Notadj(Temp1,I1) = Notadj(Temp3,I3))  then  --7/13
                           Adjneighpoint(Icount):=Notadj(Temp1,I1);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I1:=I1+1;I3:=I3+1;
                           if I1 > Notadjsizes(Temp1) then I1finished:=True; end if; 
                           if I3 > Notadjsizes(Temp3) then I3finished:=True; end if; 
                        elsif ((Notadj(Temp1,I1) < Notadj(Temp2,I2)) and Notadj(Temp2,I2) < Notadj(Temp3,I3) and Notadj(Temp1,I1) < Notadj(Temp3,I3))  then  --8/13
                           Adjneighpoint(Icount):=Notadj(Temp1,I1);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I1:=I1+1;
                           if I1 > Notadjsizes(Temp1) then I1finished:=True; end if;                     
                        elsif ((Notadj(Temp1,I1) < Notadj(Temp2,I2)) and Notadj(Temp2,I2) > Notadj(Temp3,I3) and Notadj(Temp1,I1) > Notadj(Temp3,I3))  then  --9/13
                           Adjneighpoint(Icount):=Notadj(Temp3,I3);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I3:=I3+1;
                           if I3 > Notadjsizes(Temp3) then I3finished:=True; end if; 
                        elsif ((Notadj(Temp1,I1) < Notadj(Temp2,I2)) and Notadj(Temp2,I2) > Notadj(Temp3,I3) and Notadj(Temp1,I1) < Notadj(Temp3,I3))  then  --10/13
                           Adjneighpoint(Icount):=Notadj(Temp1,I1);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I1:=I1+1;
                           if I1 > Notadjsizes(Temp1) then I1finished:=True; end if; 
                        elsif ((Notadj(Temp1,I1) > Notadj(Temp2,I2)) and Notadj(Temp2,I2) > Notadj(Temp3,I3) and Notadj(Temp1,I1) > Notadj(Temp3,I3))  then  --11/13
                           Adjneighpoint(Icount):=Notadj(Temp3,I3);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I3:=I3+1;
                           if I3 > Notadjsizes(Temp3) then I3finished:=True; end if;
                        elsif ((Notadj(Temp1,I1) > Notadj(Temp2,I2)) and Notadj(Temp2,I2) < Notadj(Temp3,I3) and Notadj(Temp1,I1) > Notadj(Temp3,I3))  then  --12/13
                           Adjneighpoint(Icount):=Notadj(Temp2,I2);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I2:=I2+1;
                           if I2 > Notadjsizes(Temp2) then I2finished:=True; end if;
                        elsif ((Notadj(Temp1,I1) > Notadj(Temp2,I2)) and Notadj(Temp2,I2) < Notadj(Temp3,I3) and Notadj(Temp1,I1) < Notadj(Temp3,I3))  then  --13/13
                           Adjneighpoint(Icount):=Notadj(Temp2,I2);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I2:=I2+1;
                           if I2 > Notadjsizes(Temp2) then I2finished:=True; end if;
                        end if;
                     elsif (I1finished = False and I2finished = False) and I3finished = True then 
                        if Notadj(Temp1,I1) = Notadj(Temp2,I2) then 
                           Adjneighpoint(Icount):=Notadj(Temp1,I1);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I1:=I1+1;I2:=I2+1;
                           if I1 > Notadjsizes(Temp1) then I1finished:=True; end if;
                           if I2 > Notadjsizes(Temp2) then I2finished:=True; end if;  
                        elsif Notadj(Temp1,I1) > Notadj(Temp2,I2) then 
                           Adjneighpoint(Icount):=Notadj(Temp2,I2);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1;I2:=I2+1;
                           if I2 > Notadjsizes(Temp2) then I2finished:=True; end if; 
                        elsif Notadj(Temp1,I1) < Notadj(Temp2,I2) then 
                           Adjneighpoint(Icount):=Notadj(Temp1,I1);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I1:=I1+1;
                           if I1 > Notadjsizes(Temp1) then I1finished:=True; end if;
                        end if;   
                     elsif (I1finished = False and I2finished = True) and I3finished = False then 
                        if Notadj(Temp1,I1) = Notadj(Temp3,I3) then 
                           Adjneighpoint(Icount):=Notadj(Temp1,I1);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I1:=I1+1;I3:=I3+1;
                           if I1 > Notadjsizes(Temp1) then I1finished:=True; end if;
                           if I3 > Notadjsizes(Temp3) then I3finished:=True; end if;  
                        elsif Notadj(Temp1,I1) > Notadj(Temp3,I3) then 
                           Adjneighpoint(Icount):=Notadj(Temp3,I3);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1;I3:=I3+1;
                           if I3 > Notadjsizes(Temp3) then I3finished:=True; end if; 
                        elsif Notadj(Temp1,I1) < Notadj(Temp3,I3) then 
                           Adjneighpoint(Icount):=Notadj(Temp1,I1);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I1:=I1+1;
                           if I1 > Notadjsizes(Temp1) then I1finished:=True; end if;
                        end if;   
                     elsif (I1finished = True and I2finished = False) and I3finished = False then 
                        if Notadj(Temp2,I1) = Notadj(Temp3,I3) then 
                           Adjneighpoint(Icount):=Notadj(Temp2,I1);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I2:=I2+1;I3:=I3+1;
                           if I2 > Notadjsizes(Temp2) then I2finished:=True; end if;
                           if I3 > Notadjsizes(Temp3) then I3finished:=True; end if;  
                        elsif Notadj(Temp2,I2) > Notadj(Temp3,I3) then 
                           Adjneighpoint(Icount):=Notadj(Temp3,I3);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1;I3:=I3+1;
                           if I3 > Notadjsizes(Temp3) then I3finished:=True; end if; 
                        elsif Notadj(Temp1,I2) < Notadj(Temp3,I3) then 
                           Adjneighpoint(Icount):=Notadj(Temp2,I2);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I2:=I2+1;
                           if I2 > Notadjsizes(Temp2) then I2finished:=True; end if;
                        end if;   
                     elsif (I1finished = False and I2finished = True) and I3finished = True then 
                        Adjneighpoint(Icount):=Notadj(Temp1,I1);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I1:=I1+1;
                        if I1 > Notadjsizes(Temp1) then I1finished:=True; end if;
                     elsif (I1finished = True and I2finished = False) and I3finished = True then 
                        Adjneighpoint(Icount):=Notadj(Temp2,I2);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I2:=I2+1;
                        if I2 > Notadjsizes(Temp2) then I2finished:=True; end if;
                     elsif (I1finished = True and I2finished = True) and I3finished = False then 
                        Adjneighpoint(Icount):=Notadj(Temp3,I3);Icount:=Icount+1;Adjneighsize:=Adjneighsize+1; I3:=I3+1;
                        if I3 > Notadjsizes(Temp3) then I3finished:=True; end if;
                     end if;
                  end loop; --while loop - (I1finished = False or I2finished = False) or I3finished = False
                  Jjj:=Adjneighsize;
                  while Jjj>0 loop
                     for J in 1.. Size_Threeless loop
                        if A(Threeless(J),Adjneighpoint(Jjj))=0 then 
                           if Jjj = Adjneighsize then Adjneighsize:=Adjneighsize-1; exit; else
                              Temp:=Adjneighpoint(Jjj);Adjneighpoint(Jjj):=Adjneighpoint(Adjneighsize);
                              Adjneighpoint(Adjneighsize):=Temp;Adjneighsize:=Adjneighsize-1; exit; 
                           end if;
                        end if;
                     end loop; 
                     Jjj:=Jjj-1;
                  end loop;--while Jjj>0 loop      
                  if Adjneighsize > 3 then 
                     declare 
                        Adjneighpointsmall:One_D_Integer(1..Adjneighsize);
                     begin
                        for I in 1..Adjneighsize loop Adjneighpointsmall(I):=Adjneighpoint(I); end loop;
                        --Carraghanpardalos(Threeless,0,Adjneighpointsmall,Adjneighsize,4);
                        Carraghanpardalos6plus(Adjneighpointsmall,Adjneighsize,4);
                     end;
                     if Bestsize > 3 then 
                        for I in 1..Bestsize loop Current_Opt(I):=Best(I);end loop;
                        for I in 1..Size_Threeless loop Current_Opt(Bestsize+I):=Threeless(I);end loop;
                        Size_Current_Opt:=Bestsize+Size_Threeless;
                        --Put("SIZE CURRENT OPT = ");Put(Size_Current_Opt, Width=>3);New_Line;
                        if Size_Current_Opt > Size_Current_Best_Opt then 
                           Size_Current_Best_Opt:=Size_Current_Opt;Current_Best_Opt:=Current_Opt;
                        end if;
                        Three_Opt_Recursive(V,Size_Current_Opt,Current_Opt);                     
                     end if; --Bestsize > 3
                  end if; --adjneighsize > 3
               end loop; -- Vvk in
            end loop; -- Vvj in
         end loop; -- Vvi in
      end Three_Opt_Recursive;

      procedure Ts_Opt(V:in Integer; Size_Current_Best_Clique: in out Integer; Current_Best_Clique: in out One_D_Integer) is
         Adjneighpoint,Besttabu,Bestall:One_D_Integer(1..Adjsizesmax);
         Tscurrent,Tstemp,Oneless:One_D_Integer(1..Target);      
         Tabulist:One_D_Integer(1..Tabutenure):=(1..Tabutenure=>0);
         Adjneighsize,Size_Tscurrent,Size_Tstemp,Tabupointer,Tabulistsize,Tscount,Sizebesttabu,Sizebestall,Bestallsetsize,Besttabusetsize,Bestv3,
         Mindeg,Degdeg,Minvert,Vvi,Vg,Size_Oneless,Verti,Vtex,Actualdelete,Actualdeleteposn,Ipointer,Temp,Tsthresh,Tsimprovecount,Clqloopsize,Ihere:Integer;
         Tsimprove,Aspiration,Normalexit:Boolean;
         Ts_Starttime,Ts_Endtime:Long_Integer;
         --Ch:Character;
      begin
         Now:=Clock;
         Ts_Starttime:=Long_Integer(Integer(Day(Now)-Ddays)*86400)+(Long_Integer(Seconds(Now))-Long_Integer(Sseconds));
         Ts_Endtime:=Ts_Starttime;
         Tsbest:=Current_Best_Clique;Size_Tsbest:=Size_Current_Best_Clique;
         Tabupointer:=0;Tabulistsize:=0;
         Put("TS START");New_Line;
         Tscurrent:=Tsbest;Size_Tscurrent:=Size_Tsbest;
         Tsimprove:=True;
         Tscount:=0;Tsimprovecount:=0;
         while Tsimprovecount < 10000 or Tsimprove = True loop --exit ts if 10000 ts iterations without improvement
         --while Ts_Endtime-Ts_Starttime < Tabusearchtime or Tsimprove = True loop 
            Tscount:=Tscount+1;Tsimprovecount:=Tsimprovecount+1;
            Tsimprove:=False;
            Aspiration:=False;
            Sizebesttabu:=0;Sizebestall:=Size_Tscurrent;Bestv3:=0;Bestallsetsize:=0;Besttabusetsize:=0;         
            --EXAMINE REMOVAL OF ALL VERTICES IF Size_Tscurrent < 362  ELSE JUST CONSIDER REMOVAL OF 100 VERTICES-BEST FOR JUST MANN_A81 IN CURRENT SET OF BENCHMARKS
            if Size_Tscurrent < 362 then Clqloopsize:=Size_Tscurrent; else Clqloopsize:=100; end if;
            for Ijk in 1..Clqloopsize loop 
               if Size_Tscurrent < 362 then Vvi:=Tscurrent(Ijk);Ihere:=Ijk; else Ihere:=Randomsubset(Size_Tscurrent);Vvi:=Tscurrent(Ihere);end if;
               Oneless:=Tscurrent;Size_Oneless:=Size_Tscurrent;
               if Ihere = Size_Oneless then Size_Oneless:=Size_Oneless-1; else
                  Oneless(Ihere):=Oneless(Size_Oneless);
                  Oneless(Size_Oneless):=Vvi;
                  Size_Oneless:=Size_Oneless-1;
               end if;
               Mindeg:=99999;
               for I in 1..Size_Oneless loop Vg:=Oneless(I);Degdeg:= Adjsizes(Vg); if Degdeg < Mindeg then Minvert:=Vg;Mindeg:=Degdeg; end if; end loop;
               Adjneighsize:=Adjsizes(Minvert);
               for I in 1..Adjsizes(Minvert) loop Adjneighpoint(I):=Adj(Minvert,I);end loop;
               Ipointer:=1; 
               while Ipointer <= Adjneighsize loop 
                  Verti:=Adjneighpoint(Ipointer);
                  Normalexit:=True;
                  for J in 1..Size_Oneless loop 
                     Vtex:=Oneless(J);
                     if Vtex = Verti or A(Vtex,Verti) = 0 then
                        Adjneighpoint(Ipointer):=Adjneighpoint(Adjneighsize);Adjneighpoint(Adjneighsize):=Verti;
                        Adjneighsize:=Adjneighsize-1;Normalexit:=False;exit;
                     end if;
                  end loop;
                  if Normalexit=True then Ipointer:=Ipointer+1;end if;  
               end loop;
               Bestsize:=0; 
               if Size_Tsbest>Sizebestall then Tsthresh:=Size_Tsbest; else Tsthresh:=Sizebestall; end if;
               declare 
                  Adjneighpointsmall:One_D_Integer(1..Adjneighsize);
               begin
                  for I in 1..Adjneighsize loop Adjneighpointsmall(I):=Adjneighpoint(I); end loop;
                  Carraghanpardalos6plus(Adjneighpointsmall,Adjneighsize,Tsthresh-Size_Oneless+1);
               end; 
               for I in 1..Bestsize loop Tstemp(I):=Best(I);end loop;
               for I in 1..Size_Oneless loop Tstemp(Bestsize+I):=Oneless(I);end loop;
               Size_Tstemp:=Bestsize+Size_Oneless;
               --ASPIRATION
               if Size_Tstemp > Size_Tsbest and Size_Tstemp > Sizebestall then 
                  Aspiration:=True;Tsimprove:=True;Sizebestall:=Size_Tstemp; Bestallsetsize:=1;Bestall(1):=Vvi;
               elsif  
                  Aspiration = True and Size_Tstemp = Sizebestall then 
                  Bestallsetsize:=Bestallsetsize+1;Bestall(Bestallsetsize):=Vvi;          
               end if;--END ASPIRATION   
               Ipointer:=1; 
               while Ipointer <= Adjneighsize loop 
                  Verti:=Adjneighpoint(Ipointer);
                  Normalexit:=True;
                  for J in 1..Tabulistsize loop
                     if Verti=Tabulist(J) then Adjneighpoint(Ipointer):=Adjneighpoint(Adjneighsize);Adjneighpoint(Adjneighsize):=Verti;Adjneighsize:=Adjneighsize-1;Normalexit:=False;exit;end if;
                  end loop;
                  if Normalexit=True and Verti = Vvi then 
                     Adjneighpoint(Ipointer):=Adjneighpoint(Adjneighsize);Adjneighpoint(Adjneighsize):=Verti;Adjneighsize:=Adjneighsize-1;             
                  elsif Normalexit=True then Ipointer:=Ipointer+1;
                  end if;
               end loop;
               if Adjneighsize > 0 then 
                  Bestsize:=0; 
                  declare 
                     Adjneighpointsmall:One_D_Integer(1..Adjneighsize);
                  begin
                     for I in 1..Adjneighsize loop Adjneighpointsmall(I):=Adjneighpoint(I); end loop;
                     Carraghanpardalos6plus(Adjneighpointsmall,Adjneighsize,0);
                  end; 
               else Bestsize:=0;
               end if;
               for I in 1..Bestsize loop Tstemp(I):=Best(I);end loop;
               for I in 1..Size_Oneless loop Tstemp(Bestsize+I):=Oneless(I);end loop;
               Size_Tstemp:=Bestsize+Size_Oneless;
               --NOT ASPIRATION - NEW TABU STARTS
               if Size_Tstemp > Sizebesttabu then Sizebesttabu:=Size_Tstemp;Besttabusetsize:=1;Besttabu(1):=Vvi; 
               else
                  if Bestsize > 1 and Size_Tstemp = Sizebesttabu then Besttabusetsize:=Besttabusetsize+1;Besttabu(Besttabusetsize):=Vvi; 
                  else
                     if ((Bestsize = 1 and Size_Tstemp = Sizebesttabu) and Adjneighsize > 1) and Adjneighsize > Bestv3 then Bestv3:=Adjneighsize;Besttabusetsize:=1;Besttabu(1):=Vvi;
                     else
                        if ((Bestsize = 1 and Size_Tstemp = Sizebesttabu) and Adjneighsize > 1) and Adjneighsize = Bestv3 then Besttabusetsize:=Besttabusetsize+1;Besttabu(Besttabusetsize):=Vvi;end if;
                     end if; --((Bestsize = 1 and Size_Tstemp = Sizebesttabu)
                  end if; --Bestsize > 1 and Size_Tstemp = Sizebesttabu
               end if;  --END NOT ASPIRATION - NEW TABU ENDS
               if Size_Tscurrent < 362 then Clqloopsize:=Size_Tscurrent; else Clqloopsize:=100; end if;
            end loop; --Ihere in 1..Size_Tscurrent 
            --------------------------------------------------------------------find best all and tabu ends
            if Aspiration = True then Actualdeleteposn:=Randomsubset(Bestallsetsize);
               Actualdelete:=Bestall(Actualdeleteposn);         
               Oneless:=Tscurrent;Size_Oneless:=Size_Tscurrent;
               for I in 1..Size_Oneless loop
                  if Oneless(I) = Actualdelete then 
                     Oneless(I):=Oneless(Size_Oneless);Oneless(Size_Oneless):=Actualdelete;Size_Oneless:=Size_Oneless-1;
                  end if;
               end loop; 
               Mindeg:=99999;
               for I in 1..Size_Oneless loop Vg:=Oneless(I);Degdeg:= Adjsizes(Vg); if Degdeg < Mindeg then Minvert:=Vg;Mindeg:=Degdeg; end if; end loop;
               Adjneighsize:=Adjsizes(Minvert);
               for I in 1..Adjsizes(Minvert) loop Adjneighpoint(I):=Adj(Minvert,I);end loop;           
               Ipointer:=1; 
               while Ipointer <= Adjneighsize loop 
                  Verti:=Adjneighpoint(Ipointer);
                  Normalexit:=True;
                  for J in 1..Size_Oneless loop Vtex:=Oneless(J);
                     if Vtex = Verti or A(Vtex,Verti) = 0 then
                        Adjneighpoint(Ipointer):=Adjneighpoint(Adjneighsize);Adjneighpoint(Adjneighsize):=Verti;Adjneighsize:=Adjneighsize-1;Normalexit:=False;exit;
                     end if;
                  end loop;
                  if Normalexit=True then Ipointer:=Ipointer+1;end if;
               end loop;
               Bestsize:=0;
               --if Adjneighsize > 0 then            
               declare 
                  Adjneighpointsmall:One_D_Integer(1..Adjneighsize);
               begin
                  for I in 1..Adjneighsize loop Adjneighpointsmall(I):=Adjneighpoint(I); end loop;
                  Carraghanpardalos6plus(Adjneighpointsmall,Adjneighsize,Sizebestall-Size_Oneless);
               end; 
               for I in 1..Bestsize loop Tscurrent(I):=Best(I);end loop;
               for I in 1..Size_Oneless loop Tscurrent(Bestsize+I):=Oneless(I);end loop;
               Size_Tscurrent:=Bestsize+Size_Oneless;
               Tsbest:=Tscurrent;Size_Tsbest:=Size_Tscurrent;
               Now:=Clock;Ts_Starttime:=Long_Integer(Integer(Day(Now)-Ddays)*86400)+(Long_Integer(Seconds(Now))-Long_Integer(Sseconds));
                 
                  Tsimprovecount:=0;
               Put("ASPIRATION");Put(" tscount = ");Put(Tscount);Put("  Size_Tscurrent was ");Put(Size_Oneless);New_Line;
               Put("  time from start of search = ");Put(Ts_Starttime); Put("    Size_Tsbest = ");Put(Size_Tsbest);New_Line;
               if Size_Tsbest >= Objective_value then
                  New_Line(Logfile);
                  Put(Logfile,"************ Clique of size  "); Put(Logfile,Size_Tsbest); Put(Logfile,"  found in ");Put(Logfile,Ts_Starttime); Put(Logfile," seconds from start of search");
                  Put(Logfile,"   adjchoices = ");Put(Logfile,Adjchoices); New_Line(Logfile);
                  --Put(Logfile,"************ Clique = "); New_Line(Logfile);
                  Put(Logfile,"{ ");
                  First:=True;            
                  for I2 in 1..Size_Tsbest loop  
                     if First = False then Put(Logfile,", "); end if;First:=False;
                     Put(Logfile,Tsbest(I2),Width=>1);
                  end loop;Put(Logfile," }");New_Line(Logfile);New_Line(Logfile);Flush(logfile);              
               end if; --Size_Tsbest >= Objective_value
            else          
               Actualdeleteposn:=Randomsubset(Besttabusetsize);
               Actualdelete:=Besttabu(Actualdeleteposn);  
               Oneless:=Tscurrent;Size_Oneless:=Size_Tscurrent;
               for I in 1..Size_Oneless loop
                  if Oneless(I) = Actualdelete then 
                     Oneless(I):=Oneless(Size_Oneless);Oneless(Size_Oneless):=Actualdelete;Size_Oneless:=Size_Oneless-1;exit;
                  end if;
               end loop;
               Tscurrent:=Oneless;
               Size_Tscurrent:=Size_Oneless;
               if Ts_Output then 
                  Put("Size_Tscurrent = ");Put(Size_Tscurrent);Put(" Adjneighsize = ");Put(Adjneighsize);New_Line;Flush;
               end if;
            end if; --aspiration eq true
            if Tabulistsize < Tabutenure then 
               Tabulist(Tabulistsize+1):=Actualdelete;Tabulistsize:=Tabulistsize+1;Tabupointer:=Tabupointer+1;else       
               Tabulist((Tabupointer mod Tabutenure) +1):=Actualdelete; Tabupointer:=(Tabupointer mod Tabutenure) +1; 
            end if;
            if Size_Tscurrent <= Tssetmin + 1 then 
               Mindeg:=99999;
               for I in 1..Size_Oneless loop Vg:=Oneless(I);Degdeg:= Adjsizes(Vg); if Degdeg < Mindeg then Minvert:=Vg;Mindeg:=Degdeg; end if; end loop;
               Adjneighsize:=Adjsizes(Minvert);
               for I in 1..Adjsizes(Minvert) loop Adjneighpoint(I):=Adj(Minvert,I);end loop;         
               Ipointer:=1; 
               while Ipointer <= Adjneighsize loop 
                  Verti:=Adjneighpoint(Ipointer);
                  Normalexit:=True;
                  for J in 1..Size_Oneless loop Vtex:=Oneless(J);
                     if Vtex = Verti or A(Vtex,Verti) = 0 then
                        Adjneighpoint(Ipointer):=Adjneighpoint(Adjneighsize);Adjneighpoint(Adjneighsize):=Verti;Adjneighsize:=Adjneighsize-1;Normalexit:=False;exit;
                     end if;
                  end loop;
                  if Normalexit=True then Ipointer:=Ipointer+1;end if;
               end loop;
               for I in 1..Adjneighsize loop
                  for J in 1..Tabulistsize loop
                     if Adjneighpoint(I)=Tabulist(J) then Temp:=Adjneighpoint(I);Adjneighpoint(I):=Adjneighpoint(Adjneighsize);Adjneighpoint(Adjneighsize):=Temp;Adjneighsize:=Adjneighsize-1;exit;end if;
                  end loop;
               end loop; 
               if Adjneighsize < Exact_Search_Threshold2 then       
                  Bestsize:=0; 
                  if Adjneighsize > 0 then    
                     declare 
                        Adjneighpointsmall:One_D_Integer(1..Adjneighsize);
                     begin
                        for I in 1..Adjneighsize loop Adjneighpointsmall(I):=Adjneighpoint(I); end loop;
                        Carraghanpardalos6plus(Adjneighpointsmall,Adjneighsize,0);
                     end;
                  else Bestsize:=0; 
                  end if; -- if Adjneighsize > 0
               else Bestsize := 1; Best(1):=Adjneighpoint(Randomsubset(Adjneighsize));--Put("Added at random");Put(Best(1));New_Line;
               end if; --if adjneighsize < Exact_Search_Threshold2 then
               for I in 1..Bestsize loop Tscurrent(I):=Best(I);end loop;
               for I in 1..Size_Oneless loop Tscurrent(Bestsize+I):=Oneless(I);end loop;
               Size_Tscurrent:=Bestsize+Size_Oneless;
            end if; --Size_Tscurrent <= Tssetmin + 1
            Now:=Clock;
            Ts_Endtime:=Long_Integer(Integer(Day(Now)-Ddays)*86400)+(Long_Integer(Seconds(Now))-Long_Integer(Sseconds)); 
         end loop; --Ts_Endtime-Ts_Starttime < Tabusearchtime or Tsimprove = True
         if Size_Current_Best_Clique > Size_Tsbest then Tsbest:=Current_Best_Clique;Size_Tsbest:=Size_Current_Best_Clique;end if;
         --Put(" Size Tsbest Finally = "); Put(Size_Tsbest);New_Line;Flush;end if;
         if Size_Tsbest > Size_Current_Best_Clique then Current_Best_Clique:=Tsbest;Size_Current_Best_Clique:=Size_Tsbest;end if;
         --Put(Logfile,"  tscount = ");Put(Logfile,Tscount);New_Line(Logfile);end if;
         Put("END TS OPT");New_Line;Totaltscount:=Totaltscount+Long_Integer(Tscount);
         Put("  tscount = ");Put(Tscount);New_Line;Put("  Totaltscount = ");Put(Totaltscount);New_Line;
         --Put(Logfile,"  tscount = ");Put(Logfile,Tscount);New_Line(Logfile);
      end Ts_Opt;
     
   begin
      Readinline1(V,E);
      Put("V = ");Put(V);Put("  E =");Put(E);New_Line;
      Density:=2.0*Float(E)/(Float(V)*(Float(V)-1.0)); Put("Density = "); Put(Density);
      Exact_Search_Threshold1:=80;Exact_Search_Threshold2:=60;
      if Density < 0.95 then Exact_Search_Threshold1:=100;Exact_Search_Threshold2:=80; end if;
      if Density < 0.9 then Exact_Search_Threshold1:=140;Exact_Search_Threshold2:=120; end if;
      if Density < 0.84 then Exact_Search_Threshold1:=160;Exact_Search_Threshold2:=140; end if;
      if Density < 0.74 then Exact_Search_Threshold1:=180;Exact_Search_Threshold2:=160; end if;
      declare
         Current_Best_Clique:One_D_Integer(1..Target);
         Overall_Best_Clique:One_D_Integer(1..Target);
      begin
         A:=new Two_D(1..V,1..V);  
         Adjsizes:=new One_D_Integer(1..V);   
         Notadjsizes:=new One_D_Integer(1..V);
         Size_Overall_Best_Clique:=0;
         for I in 1..V loop 
            for J in 1..V loop         
               A(I,J):=0;
            end loop;       
         end loop;
         Readin(V,E,A); 
         New_Line; 
         Adjsizesmax:=0;
         Notadjsizesmax:=0;
         for I in 1..V loop Adjsizes(I):=0;Notadjsizes(I):=0; end loop;
         for I in 1..V loop
            for J in 1..V loop 
               if I /= J then  if A(I,J) = 0 then Notadjsizes(I):= Notadjsizes(I)+1;else Adjsizes(I):=Adjsizes(I)+1; end if;end if;
            end loop;
            if Adjsizes(I) > Adjsizesmax then Adjsizesmax:=Adjsizes(I); end if;      
            if Notadjsizes(I) > Notadjsizesmax then Notadjsizesmax:=Notadjsizes(I); end if;
         end loop;
         Put("Adjsizesmax = ");Put(Adjsizesmax);New_Line;
         Put("Notadjsizesmax = ");Put(Notadjsizesmax);New_Line;
         Adj:=new Two_D_Integer(1..V,1..Adjsizesmax);
         Notadj:=new Two_D_Integer(1..V,1..Notadjsizesmax);
         for I in 1..V loop
            K:=1;K2:=1;
            for J in 1..V loop 
               if I /= J then if A(I,J) = 0  then Notadj(I,K):=J; K:=K+1; else Adj(I,K2):=J; K2:=K2+1;end if; end if;
            end loop;      
         end loop;
         Put("File read and analysed");New_Line;
         --FIND THETA VALUES HERE
         Starting:=True;
         First_Best:=1;First_Best_Repeat:=False;
         Second_Best:=0;
         for i in 1..100 loop
            Ik:=Long_Integer(I);
            Heur(V,Ik,Size_Current_Best_Clique,Current_Best_Clique);
            if Size_Current_Best_Clique = First_Best then First_Best_Repeat:=True; end if;
            if Size_Current_Best_Clique > First_Best then  
            Second_Best:=First_Best; First_Best:=Size_Current_Best_Clique; First_Best_Repeat:=False;end if;
            if Size_Current_Best_Clique < First_Best and Size_Current_Best_Clique > Second_Best then Second_Best:=Size_Current_Best_Clique; end if;
         end loop;
         Starting:=False;
         if First_Best_Repeat then Theta_Value:=First_Best; else Theta_Value:=Second_Best;end if;
         Threshold_For_One_Opt:=Theta_Value;
         Threshold_For_Two_Opt:=Theta_Value;
         Threshold_For_Three_Opt:=Theta_Value;
         Threshold_For_Ts_Opt:=Theta_Value;
         tssetmin:=Theta_value-15;
         --FIND THETA VALUES HERE END
         Get_Line(Infile,Tempfilename,Line_Length);
         Create(File=>Logfile,Mode=>Out_File,Name=>Readfilename(Line_Length));
         Close(Infile);
         if Usecustomtssetmin then tssetmin:=Custom_Tssetmin; end if;
         if Usecustomparameters then
            Threshold_For_One_Opt:=Custom_Threshold_For_One_Opt;
            Threshold_For_Two_Opt:=Custom_Threshold_For_Two_Opt;
            Threshold_For_Three_Opt:=Custom_Threshold_For_Three_Opt;
            Threshold_For_Ts_Opt:=Custom_Threshold_For_Ts_Opt;
            Exact_Search_Threshold1:=Custom_Exact_Search_Threshold1;
            Exact_Search_Threshold2:=Custom_Exact_Search_Threshold2;
         end if;   
         Put("threshold_for_one_opt =  ");Put(Threshold_For_One_Opt);New_Line;
         Put("threshold_for_two_opt =  ");Put(Threshold_For_Two_Opt);New_Line;
         Put("threshold_for_three_opt = ");Put(Threshold_For_Three_Opt);New_Line;
         Put("threshold_for_ts_opt  =  ");Put(Threshold_For_Ts_Opt);New_Line;            
         Put("tabutenure = ");Put(Tabutenure);New_Line;
         Put("tssetmin =    ");Put(Tssetmin);New_Line; 
         Put("exact_search_threshold1 =");Put(Exact_Search_Threshold1);New_Line;
         Put("exact_search_threshold2 =");Put(Exact_Search_Threshold2);New_Line;
         Put(Logfile,"threshold_for_one_opt = ");Put(Logfile,Threshold_For_One_Opt);New_Line(Logfile);
         Put(Logfile,"threshold_for_two_opt = ");Put(Logfile,Threshold_For_Two_Opt);New_Line(Logfile);
         Put(Logfile,"threshold_for_three_opt = ");Put(Logfile,Threshold_For_Three_Opt);New_Line(Logfile);
         Put(Logfile,"threshold_for_ts_opt  = ");Put(Logfile,Threshold_For_Ts_Opt);New_Line(Logfile);          
         Put(Logfile,"tabutenure =  ");Put(Logfile,Tabutenure);New_Line(Logfile);
         Put(Logfile,"tssetmin =     ");Put(Logfile,Tssetmin);New_Line(Logfile); 
         Put(Logfile,"exact_search_threshold1 =");Put(Logfile,Exact_Search_Threshold1);New_Line(Logfile);
         Put(Logfile,"exact_search_threshold2 =");Put(Logfile,Exact_Search_Threshold2);New_Line(Logfile);
         Put("start search");New_Line;Put(Logfile,"start search");New_Line(Logfile);Flush(Logfile);
         Randomstv.Reset (Gen => G);  -- starts G from time of day clock 
         Now:=Clock;
         Ddays:=Integer(Day(Now));Sseconds:=Long_Integer(Seconds(Now));
         Put("Time now (Day, Seconds) is ");Put(Ddays,Width=>3);Put(", ");Put(Sseconds);New_Line;
         Put(Logfile,"Time now (Day, Seconds) is ");Put(Logfile,Ddays,Width=>3);Put(Logfile,", ");Put(Logfile,Sseconds);New_Line(Logfile);
         Bestsize:=0;
         for I in 1..Target loop Best(I):=0; end loop;      
         for Ij in 1..Ijiter loop
            Heur(V,Ij,Size_Current_Best_Clique,Current_Best_Clique); 
            if Size_Current_Best_Clique >=  Threshold_For_One_Opt  then
               Now:=Clock;
               Elapsed_Start:=Long_Integer(Integer(Day(Now)-Ddays)*86400)+(Long_Integer(Seconds(Now))-Long_Integer(Sseconds));
               Size_Before:=Size_Current_Best_Clique;
               Size_Current_Best_Opt:=Size_Before;
               Size_Current_Opt:=Size_Before;
               Current_Best_Opt:=Current_Best_Clique;
               One_Opt_Recursive(V,Size_Current_Best_Clique,Current_Best_Clique);
               Size_Current_Best_Clique:=Size_Current_Best_Opt;
               Current_Best_Clique:=Current_Best_Opt;          
            end if;               
            if Size_Current_Best_Clique >=  Threshold_For_Ts_Opt  then
               Now:=Clock;
               Elapsed_Start:=Long_Integer(Integer(Day(Now)-Ddays)*86400)+(Long_Integer(Seconds(Now))-Long_Integer(Sseconds));
               Size_Before:=Size_Current_Best_Clique;
               --Size_Current_Best_Opt:=Size_Before;
               --Size_Current_Opt:=Size_Before;
               --Current_Best_Opt:=Current_Best_Clique;
               Ts_Opt(V,Size_Current_Best_Clique,Current_Best_Clique);      
               Size_Current_Best_Clique:=Size_Tsbest;
               Current_Best_Clique:=Tsbest;
               if Size_Current_Best_Clique > Size_Before and Size_Current_Best_Clique >= Size_Overall_Best_Clique then
                  Now:=Clock;
                  Elapsed:=Long_Integer(Integer(Day(Now)-Ddays)*86400)+(Long_Integer(Seconds(Now))-Long_Integer(Sseconds));
                  Put("Time for TS opt (Seconds) is ");Put(Elapsed-Elapsed_Start,Width=>15);New_Line;
                  Put(Logfile,"Time for Ts opt (Seconds) is ");Put(Logfile,Elapsed-Elapsed_Start,Width=>15);New_Line(Logfile);
                  Put("TS_OPT IMPROVEMENT FROM  ");Put(Size_Before);Put("  to  ");Put(Size_Current_Best_Clique);New_Line;
                  Put(Logfile,"TS_OPT IMPROVEMENT FROM  ");Put(Logfile,Size_Before);Put(Logfile,"  to  ");Put(Logfile,Size_Current_Best_Clique);New_Line(Logfile);Flush(Logfile);
               end if;            
            end if;       
            if (Size_Current_Best_Clique >=  Threshold_For_Two_Opt) and (Size_Current_Best_Clique > 200) then
               Now:=Clock;
               Elapsed_Start:=Long_Integer(Integer(Day(Now)-Ddays)*86400)+(Long_Integer(Seconds(Now))-Long_Integer(Sseconds));
               Size_Before:=Size_Current_Best_Clique;
               Size_Current_Best_Opt:=Size_Before;
               Size_Current_Opt:=Size_Before;
               Current_Best_Opt:=Current_Best_Clique;
               Two_Opt_Recursive(V,Size_Current_Best_Clique,Current_Best_Clique);
               Size_Current_Best_Clique:=Size_Current_Best_Opt;
               Current_Best_Clique:=Current_Best_Opt;
               if Size_Current_Best_Clique > Size_Before and Size_Current_Best_Clique >= Size_Overall_Best_Clique then
                  Now:=Clock;
                  Elapsed:=Long_Integer(Integer(Day(Now)-Ddays)*86400)+(Long_Integer(Seconds(Now))-Long_Integer(Sseconds));
                  Put("  Time for two opt (Seconds) is ");Put(Elapsed-Elapsed_Start,Width=>15);New_Line;
                  Put(Logfile,"  Time for two opt (Seconds) is ");Put(Logfile,Elapsed-Elapsed_Start,Width=>15);New_Line(Logfile);
                  Put("TWO_OPT IMPROVEMENT FROM  ");Put(Size_Before);Put("  to  ");Put(Size_Current_Best_Clique);New_Line;
                  Put(Logfile,"TWO_OPT IMPROVEMENT FROM  ");Put(Logfile,Size_Before);Put(Logfile,"  to  ");Put(Logfile,Size_Current_Best_Clique);New_Line(Logfile);Flush(Logfile);
               end if;            
            end if;         
            if (Size_Current_Best_Clique >=  Threshold_For_Three_Opt) and (Size_Current_Best_Clique <=200) then
               Now:=Clock;
               Elapsed_Start:=Long_Integer(Integer(Day(Now)-Ddays)*86400)+(Long_Integer(Seconds(Now))-Long_Integer(Sseconds));
               Size_Before:=Size_Current_Best_Clique;
               Size_Current_Best_Opt:=Size_Before;
               Size_Current_Opt:=Size_Before;
               Current_Best_Opt:=Current_Best_Clique;
               Put("start 3-opt");New_Line;
               Three_Opt_Recursive(V,Size_Current_Best_Clique,Current_Best_Clique);
               Now:=Clock;
               Elapsed:=Long_Integer(Integer(Day(Now)-Ddays)*86400)+(Long_Integer(Seconds(Now))-Long_Integer(Sseconds));
               Put("  Time for three opt (Seconds) is ");Put(Elapsed-Elapsed_Start,Width=>15);New_Line;           
               Size_Current_Best_Clique:=Size_Current_Best_Opt;
               Current_Best_Clique:=Current_Best_Opt;
               if Size_Current_Best_Clique > Size_Before and Size_Current_Best_Clique >= Size_Overall_Best_Clique then
                  Now:=Clock;
                  Elapsed:=Long_Integer(Integer(Day(Now)-Ddays)*86400)+(Long_Integer(Seconds(Now))-Long_Integer(Sseconds));
                  Put("  Time for three opt (Seconds) is ");Put(Elapsed-Elapsed_Start,Width=>15);New_Line;
                  Put(Logfile,"  Time for three opt (Seconds) is ");Put(Logfile,Elapsed-Elapsed_Start,Width=>15);New_Line(Logfile);
                  Put("THREE_OPT IMPROVEMENT FROM  ");Put(Size_Before);Put("  to  ");Put(Size_Current_Best_Clique);New_Line;
                  Put(Logfile,"THREE_OPT IMPROVEMENT FROM  ");Put(Logfile,Size_Before);Put(Logfile,"  to  ");Put(Logfile,Size_Current_Best_Clique);New_Line(Logfile);Flush(Logfile);
               end if;            
            end if;   
            if Size_Current_Best_Clique >= Threshold_For_One_Opt then
               Put("Size_Current_Best_Clique = "); Put(Size_Current_Best_Clique,Width=>4);New_Line;
               Put("  ij =");Put(Ij,Width=>10);Put("   adjchoices = ");Put(Adjchoices,Width=>4); New_Line;
               Now:=Clock;
               Elapsed:=Long_Integer(Integer(Day(Now)-Ddays)*86400)+(Long_Integer(Seconds(Now))-Long_Integer(Sseconds));
               Put("  Elapsed time to find clique (Seconds) is ");Put(Elapsed,Width=>15);New_Line;
               if Size_Current_Best_Clique >= Size_Overall_Best_Clique then
                  Overall_Best_Clique:=Current_Best_Clique;  
                  Size_Overall_Best_Clique:=Size_Current_Best_Clique;
                  Put("Size_Overall_Best_Clique = "); Put(Size_Overall_Best_Clique);New_Line;
                  Put(Logfile,"Totaltscount = "); Put(Logfile,Totaltscount);New_Line(Logfile);
                  Put(Logfile,"Size_Overall_Best_Clique = "); Put(Logfile,Size_Overall_Best_Clique);New_Line(Logfile);
                  Put(Logfile,"Overall_Best_Clique = "); New_Line(Logfile);
                  Put(Logfile,"{ ");
                  First:=True;            
                  for I2 in 1..Size_Overall_Best_Clique loop  
                     if First = False then Put(Logfile,", "); end if;First:=False;
                     Put(Logfile,Overall_Best_Clique(I2),Width=>1);
                  end loop;Put(Logfile," }");New_Line(Logfile);New_Line(Logfile);
                  Now:=Clock;
                  Elapsed:=Long_Integer(Integer(Day(Now)-Ddays)*86400)+(Long_Integer(Seconds(Now))-Long_Integer(Sseconds));
                  Put("adjchoices = ");Put(Adjchoices); New_Line;
                  Put(Logfile,"adjchoices = ");Put(Logfile,Adjchoices); New_Line(Logfile);
                  Put("ij = ");Put(Ij);Put("  Elapsed time to find clique (Seconds) is ");Put(Elapsed,Width=>15);New_Line;
                  Put(Logfile,"ij = ");Put(Logfile,Ij);Put(Logfile,"  Elapsed time to find clique (Seconds) is ");Put(Logfile,Elapsed,Width=>15);New_Line(Logfile);
                  Isclique:=True;       
                  for Vi in 1..Size_Overall_Best_Clique loop
                     for Vj in 1..Size_Overall_Best_Clique loop
                        if Vi /= Vj and A(Overall_Best_Clique(Vi),Overall_Best_Clique(Vj)) = 0 then 
                           Put(Logfile,"not clique");Put(Logfile,Overall_Best_Clique(Vi));Put(Logfile,Overall_Best_Clique(Vj));New_Line(Logfile);Flush(Logfile);Put("NOT CLIQUE");Isclique:=False; 
                        end if;
                     end loop;
                  end loop;
                  if Isclique = True then Put("isclique = true");Put(Logfile,"isclique = true");New_Line(Logfile); 
                  else Put("isclique = false ");Put(Logfile,"isclique = false ");Get(Char);end if;New_Line;New_Line(Logfile);
                  Flush(Logfile);
               end if;
            end if;
            if Ij mod 10000 = 0 then Put(" ij = ");Put(Ij);New_Line; --make it 10000
               Put(Logfile," ij = ");Put(Logfile,Ij);New_Line(Logfile);
               Now:=Clock;
               Elapsed:=Long_Integer(Integer(Day(Now)-Ddays)*86400)+(Long_Integer(Seconds(Now))-Long_Integer(Sseconds));
               Put("Elapsed time now (Seconds) is ");Put(Elapsed,Width=>15);New_Line;
               Put(Logfile,"Elapsed time now (Seconds) is ");Put(Logfile,Elapsed,Width=>15);New_Line(Logfile);Flush(Logfile);
            end if;
         end loop;         --Ij in 1..Ijiter
         Close(Logfile);--Close(Clqfile);
      end;
   end Inside_New_Maxclq;

begin
   Open(Infile,Mode=>In_File,Name=>"HTS2_PARAMETER_FILE.txt");
   Get(Infile,Target);Skip_Line(Infile);
   Get(Infile,Objective_value);Skip_Line(Infile);
   Get(Infile,Ijiter);Skip_Line(Infile);
   Get(Infile,Ts_Output);Skip_Line(Infile);
   Get(Infile,Tabutenure);Skip_Line(Infile);
   Skip_Line(Infile);
   Get(Infile,Usecustomtssetmin);Skip_Line(Infile);
   Get(Infile,Custom_Tssetmin);Skip_Line(Infile);
   Get(Infile,Usecustomparameters);Skip_Line(Infile);
   Get(Infile,Custom_Threshold_For_One_Opt);Skip_Line(Infile);
   Get(Infile,Custom_Threshold_For_Two_Opt);Skip_Line(Infile);
   Get(Infile,Custom_Threshold_For_Three_Opt);Skip_Line(Infile);
   Get(Infile,Custom_Threshold_For_Ts_Opt);Skip_Line(Infile);
   Get(Infile,Custom_Exact_Search_Threshold1);Skip_Line(Infile);
   Get(Infile,Custom_Exact_Search_Threshold2);Skip_Line(Infile);
   Skip_Line(Infile);
   Get_Line(Infile,Tempfilename,Line_Length);
   Inside_New_Maxclq;
end HTS2;


